//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadXpsCvtDll()
{
	m_hinstLib = LoadLibrary("xpscvt.dll");
	if( m_hinstLib == NULL ){
		return FALSE;
	}
	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreeXpsCvtDll();
		return FALSE;
	}
	pMConvertToImage = (MConvertToImage *)GetProcAddress(m_hinstLib, "MConvertToImage");
	if( pMConvertToImage == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMSetImageParam = (MSetImageParam *)GetProcAddress(m_hinstLib, "MSetImageParam");
	if( pMSetImageParam == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMConvertToPDF = (MConvertToPDF *)GetProcAddress(m_hinstLib, "MConvertToPDF");
	if( pMConvertToPDF == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMPDFEncrypt = (MPDFEncrypt *)GetProcAddress(m_hinstLib, "MPDFEncrypt");
	if( pMPDFEncrypt == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMPDFInformation = (MPDFInformation *)GetProcAddress(m_hinstLib, "MPDFInformation");
	if( pMPDFInformation == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMPDFWatermark = (MPDFWatermark *)GetProcAddress(m_hinstLib, "MPDFWatermark");
	if( pMPDFWatermark == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreeXpsCvtDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadXpsCvtDll() == FALSE ){
		ShowMessage("Load xpscvt.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_TIF;
		long bitcount = BITCOUNT_24;
		long quality = 75;
		long rotate = 0;
		long width = 0;
		long height = 0;
		long xdpi = 150;
		long ydpi = 150;

		long compression = COMPRESSION_LZW;
		long multipage = 1;

		//Set Output image param
		pMSetImageParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to tiff file (multiple page)
		pMConvertToImage(id,"test.xps","","multiple");
		pMEnd(id);
	}		

	FreeXpsCvtDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadXpsCvtDll() == FALSE ){
		ShowMessage("Load xpscvt.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_JPG;
		long bitcount = BITCOUNT_8G;//256 color grayscale( 8 bits )
		long quality = 85;
		long rotate = 90;
		long width = 1000;
		long height = 800;
		long xdpi = 200;
		long ydpi = 200;
		//only for tiff
		long compression = 0;
		long multipage = 0;

		//Set Output image param
		pMSetImageParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to jpg file
		pMConvertToImage(id,"test.xps","path","jpg");
		pMEnd(id);
	}

	FreeXpsCvtDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	if( LoadXpsCvtDll() == FALSE ){
		ShowMessage("Load xpscvt.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		long angle=0;
		long xoff=0;
		long yoff=0;
		long background=1;
		//Stamping
		pMPDFWatermark(id,"Watermark",fsize,fcolor,position,angle,xoff,yoff,background);

		long level = 40;
		long printing = 1;
		long copying = 1;
		long changing = 0;
		long adding = 0;
		//Set PDF Encrypt
		pMPDFEncrypt(id,"password","password2",level,printing,copying,changing,adding);

		//Set PDF Information
		pMPDFInformation(id,"title","subject","author","keywords","creator","producer");

		pMConvertToPDF(id,"test.xps","output.pdf");
		pMEnd(id);
	}

	FreeXpsCvtDll();
	ShowMessage("Convert finished!");	
}
//---------------------------------------------------------------------------

